/*
 * Biblioteca de Funcoes para resolver sistemas Ax=B,
 * fazer pivoteamento simultneo e Eliminao Simultanea em A e B
 *----------------------------------------------------------------
 * Autores:
 * - Gustavo Sverzut Barbieri <ra008849@ic.unicamp.br> - Eng. Computao - Unicamp 
 * - Ivens Prates Teles Alves <ra008908@ic.unicamp.br> - Eng. Computao - Unicamp
 */

#ifndef _ELIM_GAUSS_H_
#define _ELIM_GAUSS_H_

#include "lib_matriz.h"
#include <math.h>
#include <stdlib.h>

void PivoteamentoParcial(Matriz *A, Matriz *B);
void EliminacaoGauss(Matriz *A, Matriz *B);
Matriz *ResolveSistemaTriangularSuperior(Matriz *A, Matriz *B, char nome[]);
double Residuo(Matriz *A, Matriz *X, Matriz *B);

#endif
